SystemOrganization addCategory: #'XPF-CodeMarker'!
SystemOrganization addCategory: #'XPF-MonticelloTest'!
SystemOrganization addCategory: #'XPF-OmniBrowserTest'!

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'topa 1/13/2009 19:36' foobar: foobar!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint XPF).
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 16:46' foobar: foobar!
toggleXPF

	self setTextInDefinitionPanel: 'blabla'! !

OBReadOnlyDefinition subclass: #XPOBRODefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-OmniBrowserTest'!

!XPOBRODefinition methodsFor: 'callbacks' stamp: 'topa 1/13/2009 19:31' foobar: foobar!
processText: aText
	^ 'Begin of meth', String cr, aText, String cr, 'End of Meth'! !

!XPOBRODefinition methodsFor: 'callbacks' stamp: 'topa 1/13/2009 19:29' foobar: foobar!
text
	^ self processText: text! !

!MCStWriter methodsFor: '*XPF' stamp: 'mt 1/13/2009 18:31' foobar: foobar!
writeMethodPreamble: definition
	stream
		cr;
		nextPut: $!!;
		nextPutAll: definition fullClassName;
		nextPutAll: ' methodsFor: ';
		nextPutAll: definition category asString printString;
		nextPutAll: ' stamp: ';
		nextPutAll: definition timeStamp asString printString;
		nextPutAll: ' foobar: ';
		nextPutAll: definition foobar;
		nextPutAll: '!!';
		cr! !

PluggableTextMorph subclass: #XPFPluggableTextMorph
	instanceVariableNames: 'styler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFPluggableTextMorph class methodsFor: 'instance creation' stamp: 'cs 1/13/2009 18:39' foobar: foobar!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	|styler answer stylerClass |
	answer := self new.
	stylerClass := Smalltalk classNamed: #XPFTextStyler "#SHTextStylerST80".
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!XPFPluggableTextMorph methodsFor: 'styling' stamp: 'cs 1/13/2009 17:11' foobar: foobar!
okToStyle

	^self styler isNil not! !

!XPFPluggableTextMorph methodsFor: 'styling' stamp: 'cs 1/13/2009 18:46' foobar: foobar!
setText: aText

	self okToStyle ifFalse: [^super setText: aText].
	super setText: (styler format: aText).
	self styler style: textMorph contents.! !

!XPFPluggableTextMorph methodsFor: 'accessing' stamp: 'cs 1/13/2009 16:58' foobar: foobar!
styler
	^ styler! !

!XPFPluggableTextMorph methodsFor: 'accessing' stamp: 'cs 1/13/2009 16:58' foobar: foobar!
styler: anObject
	styler := anObject! !

!XPFPluggableTextMorph methodsFor: 'styling' stamp: 'cs 1/13/2009 17:28' foobar: foobar!
stylerStyled: styledCopyOfText

	textMorph contents runs: styledCopyOfText runs .
	"textMorph paragraph recomposeFrom: 1 to: textMorph contents size delta: 0."  "caused chars to appear in wrong order esp. in demo mode. remove this line when sure it is fixed"
	textMorph updateFromParagraph.
	selectionInterval 
		ifNotNil:[
			textMorph editor
				selectInvisiblyFrom: selectionInterval first to: selectionInterval last;
				storeSelectionInParagraph;
				setEmphasisHere].
	self scrollSelectionIntoView! !

!MCMethodDefinition methodsFor: '*XPF' stamp: 'mt 1/13/2009 18:30' foobar: foobar!
foobar
	^'foobar'! !

SHTextStyler subclass: #XPFTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextStyler methodsFor: 'private' stamp: 'cs 1/13/2009 18:55' foobar: foobar!
privateFormat: aText

	^ aText copyReplaceTokens: 'uuu' with: 'X'! !

!XPFTextStyler methodsFor: 'private' stamp: 'cs 1/13/2009 18:38' foobar: foobar!
privateStyle: aText
	
	aText addAttribute: TextColor green from: 1 to: 3.! !

Morph subclass: #MyClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-MonticelloTest'!

!MyClass methodsFor: 'as yet unclassified' stamp: 'mt 1/13/2009 18:30' foobar: foobar!
initialize
	super initialize.
	self color: Color green! !
